diff --git a/bash_completion b/bash_completion
index 8811a70..caed40c 100644
--- a/bash_completion
+++ b/bash_completion
@@ -2586,6 +2586,17 @@ _known_hosts()
 		COMPREPLY=( "${COMPREPLY[@]}" $hosts )
 	    fi
 
+	    # Add hosts that avahi reports, if avahi is available
+	    if type avahi-browse >&/dev/null; then
+		COMPREPLY=( "${COMPREPLY[@]}" $(
+			compgen -W "$(
+                		avahi-browse -kcp _workstation._tcp \
+		                | sed 's/\\0/\\\\0/g' \
+                		| while IFS=';' read bla bla bla hostn bla bdomain; do
+		                        echo ${hostn%%\\*}.$bdomain
+                		done)" -- $ocur))
+	    fi
+
 	    # Now add results of normal hostname completion
 	    COMPREPLY=( "${COMPREPLY[@]}" $( compgen -A hostname -- $ocur ) )
 
